//Writing to object
class WriterMem {
    constructor(ref) {
        this.ref = ref;
        this.sof = true;
    }

    writeHeader() {
        this.ref.result = [];
    }

    write(data) {
        return new Promise((resolve) => {
            for(let entity of data) {
                if (this.sof) {
                    this.writeHeader();
                }
                this.sof = false;
                this.ref.result.push(entity);
            }
            resolve();
        });
    }

    end(error) {
        return new Promise((resolve, reject) => {
            if (this.sof || error) {
                this.writeHeader();
            }
            if (error) {
                this.ref.error = `${error}`;
            }
            if (error) {
                return reject(error);
            }
            resolve(this.ref);
        });
    }
}

module.exports = WriterMem;
